<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.15" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__wicedbt__utility" kind="group">
    <compoundname>wicedbt_utility</compoundname>
    <title>Utilities</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__wicedbt__utility_1ga6f76de78537f24e047f4b95c6fb91ff8" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_bt_dev_register_hci_trace</definition>
        <argsstring>(wiced_bt_hci_trace_cback_t *p_cback)</argsstring>
        <name>wiced_bt_dev_register_hci_trace</name>
        <param>
          <type><ref kindref="member" refid="group__wicedbt___device_management_1ga8b6fbcab797b63e5fa1b9eaa99a229c3">wiced_bt_hci_trace_cback_t</ref> *</type>
          <declname>p_cback</declname>
        </param>
        <briefdescription>
<para>Register to get the hci traces. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_cback</parametername>
</parameternamelist>
<parameterdescription>
<para>: Callback for hci traces</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>void </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_dev.h" line="1729" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wicedbt__utility_1gacf5c12d2e853201354c0465945b23826" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_bt_set_local_bdaddr</definition>
        <argsstring>(wiced_bt_device_address_t bd_addr, wiced_bt_ble_address_type_t addr_type)</argsstring>
        <name>wiced_bt_set_local_bdaddr</name>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1gacf9a377aceca799be625c0dfe554902e">wiced_bt_device_address_t</ref></type>
          <declname>bd_addr</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1ga97897f7408c23723933e9d21815c7294">wiced_bt_ble_address_type_t</ref></type>
          <declname>addr_type</declname>
        </param>
        <briefdescription>
<para>Set Local Bluetooth Device Address. </para>
        </briefdescription>
        <detaileddescription>
<para>If application passes BLE_ADDR_RANDOM as an address type, the stack will setup a static random address. For the static random address top two bits of the bd_addr should be set. The stack will enforce that.</para>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">bd_addr</parametername>
</parameternamelist>
<parameterdescription>
<para>: device address to use </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">addr_type</parametername>
</parameternamelist>
<parameterdescription>
<para>: device address type , should be BLE_ADDR_RANDOM or BLE_ADDR_PUBLIC BLE_ADDR_RANDOM should be only for single BLE mode, not for BR-EDR or Dual Mode</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>void</para>
</simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;BD_Address must be in Big Endian format&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Example Data | AB | CD | EF | 01 | 23 | 45 | Address | 0 | 1 | 2 | 3 | 4 | 5 | For above example it will set AB:CD:EF:01:23:45 bd address </verbatim></para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_dev.h" line="1749" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wicedbt__utility_1gaea415ed132f86dbf21dcd6bc729c9ef1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group___result_1gacfc32ead8a827d53416f01b19eb58310">wiced_result_t</ref></type>
        <definition>wiced_result_t wiced_bt_dev_get_role</definition>
        <argsstring>(wiced_bt_device_address_t remote_bd_addr, uint8_t *p_role, wiced_bt_transport_t transport)</argsstring>
        <name>wiced_bt_dev_get_role</name>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1gacf9a377aceca799be625c0dfe554902e">wiced_bt_device_address_t</ref></type>
          <declname>remote_bd_addr</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>p_role</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1gae0d25ec063a889c537f3a77010cf5ef0">wiced_bt_transport_t</ref></type>
          <declname>transport</declname>
        </param>
        <briefdescription>
<para>This function is called to get the role of the local device for the ACL connection with the specified remote device. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">remote_bd_addr</parametername>
</parameternamelist>
<parameterdescription>
<para>: BD address of remote device </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">transport</parametername>
</parameternamelist>
<parameterdescription>
<para>: BT_TRANSPORT_BR_EDR or BT_TRANSPORT_LE</para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">p_role</parametername>
</parameternamelist>
<parameterdescription>
<para>: Role of the local device</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>WICED_BT_UNKNOWN_ADDR if no active link with bd addr specified </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_dev.h" line="1765" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wicedbt__utility_1ga449c0b615910dc6de36b15b870c1d920" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group___result_1gacfc32ead8a827d53416f01b19eb58310">wiced_result_t</ref></type>
        <definition>wiced_result_t wiced_bt_set_tx_power</definition>
        <argsstring>(wiced_bt_device_address_t bd_addr, int8_t power, wiced_bt_dev_vendor_specific_command_complete_cback_t *p_cb)</argsstring>
        <name>wiced_bt_set_tx_power</name>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1gacf9a377aceca799be625c0dfe554902e">wiced_bt_device_address_t</ref></type>
          <declname>bd_addr</declname>
        </param>
        <param>
          <type>int8_t</type>
          <declname>power</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__wicedbt___device_management_1ga5efde2f4a4954a99dc729af308ce90bf">wiced_bt_dev_vendor_specific_command_complete_cback_t</ref> *</type>
          <declname>p_cb</declname>
        </param>
        <briefdescription>
<para>Command to set the tx power on link This command will adjust the transmit power attenuation on a per connection basis. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">bd_addr</parametername>
</parameternamelist>
<parameterdescription>
<para>: peer address To set Adv Tx power keep bd_addr NULL </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">power</parametername>
</parameternamelist>
<parameterdescription>
<para>: power value in db </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">p_cb</parametername>
</parameternamelist>
<parameterdescription>
<para>: Result callback (<ref kindref="compound" refid="structwiced__bt__set__adv__tx__power__result__t">wiced_bt_set_adv_tx_power_result_t</ref> will be passed to the callback)</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>wiced_result_t </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_dev.h" line="1779" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wicedbt__utility_1ga48a580210a970a52c39fca816ccfd0d7" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group___result_1gacfc32ead8a827d53416f01b19eb58310">wiced_result_t</ref></type>
        <definition>wiced_result_t wiced_bt_dev_read_tx_power</definition>
        <argsstring>(wiced_bt_device_address_t remote_bda, wiced_bt_transport_t transport, wiced_bt_dev_cmpl_cback_t *p_cback)</argsstring>
        <name>wiced_bt_dev_read_tx_power</name>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1gacf9a377aceca799be625c0dfe554902e">wiced_bt_device_address_t</ref></type>
          <declname>remote_bda</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1gae0d25ec063a889c537f3a77010cf5ef0">wiced_bt_transport_t</ref></type>
          <declname>transport</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__wicedbt___device_management_1ga2ebace7053dc297ea21b0e97cd0b1ce3">wiced_bt_dev_cmpl_cback_t</ref> *</type>
          <declname>p_cback</declname>
        </param>
        <briefdescription>
<para>Read the transmit power for the requested link. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">remote_bda</parametername>
</parameternamelist>
<parameterdescription>
<para>: BD address of connection to read tx power </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">transport</parametername>
</parameternamelist>
<parameterdescription>
<para>: Transport type </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">p_cback</parametername>
</parameternamelist>
<parameterdescription>
<para>: Result callback (<ref kindref="compound" refid="structwiced__bt__tx__power__result__t">wiced_bt_tx_power_result_t</ref> will be passed to the callback)</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para />
</simplesect>
<bold> WICED_BT_PENDING </bold> : if command issued to controller. <linebreak />
<bold> WICED_BT_NO_RESOURCES </bold> : if couldn't allocate memory to issue command <linebreak />
<bold> WICED_BT_UNKNOWN_ADDR </bold> : if no active link with bd addr specified <linebreak />
<bold> WICED_BT_BUSY </bold> : if command is already in progress </para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_dev.h" line="1796" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wicedbt__utility_1gae95344797140c44aa120d34957a576b3" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_bt_set_pairable_mode</definition>
        <argsstring>(uint8_t allow_pairing, uint8_t connect_only_paired)</argsstring>
        <name>wiced_bt_set_pairable_mode</name>
        <param>
          <type>uint8_t</type>
          <declname>allow_pairing</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>connect_only_paired</declname>
        </param>
        <briefdescription>
<para>Enable or disable pairing. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">allow_pairing</parametername>
</parameternamelist>
<parameterdescription>
<para>: (TRUE or FALSE) whether or not the device allows pairing. </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">connect_only_paired</parametername>
</parameternamelist>
<parameterdescription>
<para>: (TRUE or FALSE) whether or not to only allow paired devices to connect.</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>void </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_dev.h" line="1809" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wicedbt__utility_1ga47d967c6345178460a13cbcb9bebebd0" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group___result_1gacfc32ead8a827d53416f01b19eb58310">wiced_result_t</ref></type>
        <definition>wiced_result_t wiced_bt_dev_register_vse_callback</definition>
        <argsstring>(wiced_bt_dev_vse_callback_t cb)</argsstring>
        <name>wiced_bt_dev_register_vse_callback</name>
        <param>
          <type><ref kindref="member" refid="group__wicedbt___device_management_1gaebf936e45cd2f486d498dbd36ba8f479">wiced_bt_dev_vse_callback_t</ref></type>
          <declname>cb</declname>
        </param>
        <briefdescription>
<para>Application can register Vendor-Specific HCI event callback. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">cb</parametername>
</parameternamelist>
<parameterdescription>
<para>: callback function to register</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>WICED_SUCCESS WICED_ERROR if out of usage </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_dev.h" line="1820" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wicedbt__utility_1ga10e6d57bbd051aaf42815071f6631d6f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group___result_1gacfc32ead8a827d53416f01b19eb58310">wiced_result_t</ref></type>
        <definition>wiced_result_t wiced_bt_dev_deregister_vse_callback</definition>
        <argsstring>(wiced_bt_dev_vse_callback_t cb)</argsstring>
        <name>wiced_bt_dev_deregister_vse_callback</name>
        <param>
          <type><ref kindref="member" refid="group__wicedbt___device_management_1gaebf936e45cd2f486d498dbd36ba8f479">wiced_bt_dev_vse_callback_t</ref></type>
          <declname>cb</declname>
        </param>
        <briefdescription>
<para>Application can deregister Vendor-Specific HCI event callback. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">cb</parametername>
</parameternamelist>
<parameterdescription>
<para>: callback function to deregister</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>WICED_SUCCESS WICED_ERROR if the input callback function was not registered yet </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_dev.h" line="1831" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wicedbt__utility_1ga4ab6381d133e991f9e7472c54e0be605" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group___result_1gacfc32ead8a827d53416f01b19eb58310">wiced_bt_dev_status_t</ref></type>
        <definition>wiced_bt_dev_status_t wiced_bt_dev_link_quality_stats</definition>
        <argsstring>(wiced_bt_device_address_t bda, wiced_bt_transport_t transport, uint8_t action, wiced_bt_dev_cmpl_cback_t *p_cback)</argsstring>
        <name>wiced_bt_dev_link_quality_stats</name>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1gacf9a377aceca799be625c0dfe554902e">wiced_bt_device_address_t</ref></type>
          <declname>bda</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1gae0d25ec063a889c537f3a77010cf5ef0">wiced_bt_transport_t</ref></type>
          <declname>transport</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>action</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__wicedbt___device_management_1ga2ebace7053dc297ea21b0e97cd0b1ce3">wiced_bt_dev_cmpl_cback_t</ref> *</type>
          <declname>p_cback</declname>
        </param>
        <briefdescription>
<para>This API is called to get the statistics for an ACL link. </para>
        </briefdescription>
        <detaileddescription>
<para>Limitation This API works when there is only one ACL connection</para>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">bda</parametername>
</parameternamelist>
<parameterdescription>
<para>: bluetooth device address of desired link quality statistics </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">transport</parametername>
</parameternamelist>
<parameterdescription>
<para>: Tranport type LE/BR-EDR </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">action</parametername>
</parameternamelist>
<parameterdescription>
<para>: WICED_CLEAR_LINK_QUALITY_STATS = reset the link quality statistics to 0, WICED_READ_LINK_QUALITY_STATS = read link quality statistics, WICED_READ_THEN_CLEAR_LINK_QUALITY_STATS = read link quality statistics, then clear it </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">p_cback</parametername>
</parameternamelist>
<parameterdescription>
<para>: Result callback (wiced_bt_dev_cmpl_cback_t will be passed to the callback)</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para />
</simplesect>
<bold> WICED_BT_SUCCESS </bold> : If successful <linebreak />
<bold> WICED_BT_PENDING </bold> : If command succesfully sent down <linebreak />
<bold> WICED_BT_BUSY </bold> : If already in progress <linebreak />
<bold> WICED_BT_NO_RESORCES </bold> : If no memory/buffers available to sent down to controller <linebreak />
<bold> WICED_BT_UNKNOWN_ADDR </bold> : If given BD_ADDRESS is invalid <linebreak />
 <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Callback function argument is a pointer of type &lt;a href="structwiced__bt__lq__stats__result__t.html#"&gt;wiced_bt_lq_stats_result_t&lt;/a&gt; &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_dev.h" line="1858" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>This sections provides Bluetooth utilities functions related to trace, local bda, tx power etc. </para>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
  </compounddef>
</doxygen>